#pragma once
#include "afxcmn.h"
#include "rss_worker.h"
#include "afxwin.h"
// CIssuePickerDlg dialog

class CIssuePickerDlg : public CDialog
{
	DECLARE_DYNAMIC(CIssuePickerDlg)

public:
	CIssuePickerDlg(CWnd* pParent, HWND hWndBugID, LPCTSTR szUrlGetIssues);   // standard constructor
	virtual ~CIssuePickerDlg();
// Dialog Data
	enum { IDD = IDD_DLG_PICK };

protected:
	/*virtual*/ void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	CString m_url;
    CListCtrl m_lview;
    CComboBox m_combo;
    CButton m_requery;
    CButton m_done;
    CImageList m_imgList, m_himgList;
    enum columns { COL_BUGID, COL_SUMMARY, COL_REPORTER, COL_DUE, COL_CNT };
    int m_sortColumn; // [+1] 0: no sort, >0 asc; <0 desc
	/*virtual*/ BOOL OnInitDialog();

	afx_msg void OnBnClickedRequery();
    afx_msg void OnNMClickLvIssues(NMHDR *pNMHDR, LRESULT *pResult);
    afx_msg void OnLvnGetInfoTipLvIssues(NMHDR *pNMHDR, LRESULT *pResult);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnDestroy();
    afx_msg void OnHdnItemclickLvIssues(NMHDR *pNMHDR, LRESULT *pResult);
    afx_msg void OnBnClickedDone();

    CXML_dbRSS_Channel m_data;
    // TortoiseSVN window handle
	HWND m_hWndBugID; CString m_strInput;

    static int CALLBACK SortFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
    enum types     { JT_BUG, JT_NEWF, JT_TASK, JT_IMPROVE, JT_SUBTASK, JT_CNT };
    enum priors    { JP_BLOCKER, JP_CRIT, JP_MAJOR, JP_MINOR, JP_TRIVIAL, JP_CNT };
    enum statuses  { JS_UNASSIGNED, JS_OPEN, JS_INPROG, JS_REOPEN, JS_RESOLVED, JS_CLOSED, JS_CNT };
    enum dir_sorts { JD_NONE, JD_ASCENDING, JD_DESCENDING, JD_CNT };
    static int stGetImageIndex(types idx)     { return idx; }
    static int stGetImageIndex(priors idx)    { return idx+JT_CNT; }
    static int stGetImageIndex(statuses idx)  { return idx+JT_CNT+JP_CNT; }
    static int stGetImageIndex(dir_sorts idx) { return idx; }
    void ExchangeIniSettings(bool bSave);
    void SetSortColumn(int nNewSort);
    BOOL InputBoxContains(const CString &key) const;

    DECLARE_MESSAGE_MAP()
};
