#pragma once
#include "SAXContentHandlerImpl.h"

class CXML_dbID
{
public:
    CXML_dbID(int newVal=-1) : m_id(newVal) { }
    virtual ~CXML_dbID() {}

    operator int() const { return m_id; }
    int operator=(int newVal) { return m_id=newVal; }

private:
    int m_id;
    CXML_dbID &operator=(const CXML_dbID &src);/* { ASSERT(0); return *this; }*/
};

class CXML_dbString : public CXML_dbID
{
public:
    CXML_dbString(int id=-1) : CXML_dbID(id) {}

	CString m_value;
};

class CXML_dbUser
{
public:      
    CString m_username, m_user_full_name;
};

class CXML_dbItem
{
public:
	CString m_link;
	CXML_dbString m_key;
	CString m_summary;
	CXML_dbString m_type;
	CXML_dbString m_priority;
    CXML_dbString m_status;
	CString m_resolution;
	CXML_dbUser m_assignee;
	CXML_dbUser m_reporter;
	CString m_created, m_updated, m_due;
};

typedef CTypedPtrArray<CPtrArray, CXML_dbItem *> CXML_dbItems;

class CXML_dbRSS_Channel : public CObject
{
public:
	enum tokens {rss, channel, title, link, description, language, item, 
        key, id, summary, type, priority, 
        status, resolution, assignee, username, reporter,
        created, updated, due,
        customfields, customfield, customfieldname, customfieldvalues, customfieldvalue,
     T_CNT};
    static const wchar_t * st_c[T_CNT];

	CString m_title;
    CString m_link;
    CString m_description;
    CString m_language;
	CXML_dbItems m_items;

	void Cleanup()
    {
        for(int i=0;i<m_items.GetCount();i++)  delete m_items[i];
        m_items.RemoveAll();
    }

    ~CXML_dbRSS_Channel() { Cleanup(); }
};

class MyContent : public SAXContentHandlerImpl  
{
public:
    MyContent(CXML_dbRSS_Channel *pData);
    virtual ~MyContent();
        
        virtual HRESULT STDMETHODCALLTYPE startElement( 
            /* [in] */ wchar_t __RPC_FAR * pwchNamespaceUri,
            /* [in] */ int cchNamespaceUri,
            /* [in] */ wchar_t __RPC_FAR * pwchLocalName,
            /* [in] */ int cchLocalName,
            /* [in] */ wchar_t __RPC_FAR * pwchQName,
            /* [in] */ int cchQName,
            /* [in] */ ISAXAttributes __RPC_FAR *pAttributes);

        virtual HRESULT STDMETHODCALLTYPE characters( 
            /* [in] */ wchar_t __RPC_FAR *pwchChars,
            /* [in] */ int cchChars);
        
        virtual HRESULT STDMETHODCALLTYPE endElement( 
            /* [in] */ wchar_t __RPC_FAR * pwchNamespaceUri,
            /* [in] */ int cchNamespaceUri,
            /* [in] */ wchar_t __RPC_FAR * pwchLocalName,
            /* [in] */ int cchLocalName,
            /* [in] */ wchar_t __RPC_FAR * pwchQName,
            /* [in] */ int cchQName);

        virtual HRESULT STDMETHODCALLTYPE startDocument();

private:
      // parser
      int m_depth;
      CString *m_pChars;
      CXML_dbItem *m_pItem;

      // external data receiver
      CXML_dbRSS_Channel *m_pData;
};
